#include "Fivewin.ch"
#include "Slider.ch"

FUNCTION MAIN()
LOCAL oDlg, oBtn1, oBtn2, oSay1, oSlider, oBmp, nColor := 255
LOCAL nRed, nGreen, nBlue, nPosSlid := 0.5, nValSlid := 5, oSay3
LOCAL nColor1 := 255, cColor1 := "nRGB( 255, 0, 0 )",  nColor2 := 6736896

DEFINE FONT oFont NAME "Ariel" SIZE 0, -14 BOLD
DEFINE DIALOG oDlg FROM 5, 5 TO 510, 380 PIXEL TRUEPIXEL ; 
TITLE "COLOR - adjust   Rel. 2.1 / June 2021" FONT oFont  

// RESULT-color
@ 25, 140 SAY oSay1  PROMPT "     "  OF oDlg  SIZE 100, 40  PIXEL BORDER UPDATE
oSay1:SetColor( 0, nColor1 )
oSay1:Refresh()

@   80, 140 GET oGet1 VAR nColor1  SIZE 80, 22  PICTURE "99999999"  ;
OF oDlg  Font oFont PIXEL UPDATE 
@ 115, 140 GET oGet2 VAR cColor1  SIZE 160, 22  OF oDlg  Font oFont PIXEL UPDATE 
MAKE_RGB(nColor1)

@ 25, 15 BITMAP oBmp FILENAME NIL SIZE 50, 450 OF oDlg  ; // 0.5 * nrow 225 = 450
PIXEL  ADJUST BORDER UPDATE
oBmp:bPainted := { |hDC| GET_COLOR( 1, hDC, oBmp, nColor ) }
oBmp:bLClicked  := { | nRow, nCol | nColor1 := PICK_COLOR( nRow, 10, oBmp)[1], ; 
                                                            cColor1 := PICK_COLOR( nRow, 10, oBmp)[2], ; 
                                                            oSay1:SetColor( 0, nColor1 ), oSay1:Refresh(), ; 
                                                            nValSlid := nRow / 450, oSay2:Refresh(), ; 
                                                            nPosSlid := nValSlid, oSay2:Refresh(),;
                                                            oSlider:Set( nValSlid * 10), oSlider:Refresh(), ; 
							    oGet1:Refresh(), oGet2:Refresh() }

@ 15, 70 SLIDER oSlider VAR nValSlid OF oDlg ;
            VERTICAL ;
            RANGE 0, 10 ; 
            COLORS CLR_RED, 16770764, 255 ;
            MARKS 11;
            SIZE 25, 470 PIXEL UPDATE ;
            ON CHANGE ( nPosSlid :=  nValSlid / 10 , ;
	                               oSay2:Refresh(), ;  // 0.5 = centered
                                       nColor1 := PICK_COLOR( nValSlid * 45, 10, oBmp )[1], ;  
                                       cColor1 := PICK_COLOR( nValSlid * 45, 10, oBmp )[2], ; 
                                       oSay1:SetColor( 0, nColor1 ), oSay1:Refresh(), ; 
				       oGet1:Refresh(), oGet2:Refresh() )
oSlider:SetFont(  oFont )

@ 242, 105 SAY oSay2 PROMPT nPosSlid OF oDlg  SIZE 30, 23  PIXEL TRANSPARENT  UPDATE
oSay2:SetColor( 0, )

// -----------

@ 285, 140 SAY oSay3 PROMPT "New color-value" OF oDlg  SIZE 120, 23  PIXEL TRANSPARENT  UPDATE
oSay3:SetColor( 255, )

@ 310, 140 GET oGet3 VAR nColor2  SIZE 80, 22  PICTURE "99999999"  ;
OF oDlg  Font oFont PIXEL UPDATE 

@ 310, 250 BTNBMP oBtn1  OF oDlg ;
SIZE 100, 30 PIXEL TOP 2007 ; // B / H
PROMPT " Create " ;
ACTION ( oGet3:Refresh(), ; 
                  nColor := nColor2, ;
                  oSay1:SetColor( 0, nColor ), ; 
		  oSay1:Refresh(), ; 
		  oGet1:Refresh(), ;
		  oGet2:Refresh(), ;
		  oBmp:Refresh() ) ;				
FONT oFont BORDER  
oBtn1:cToolTip =  { "Exit color tool","EXIT", 1, CLR_BLACK, 14089979 }
oBtn1:SetColor( 0, )

// -----------

@ 462, 250 BTNBMP oBtn2  OF oDlg ;
SIZE 100, 30 PIXEL TOP 2007 ; // B / H
PROMPT " EXIT " ;
ACTION oDlg:End() ;				
FONT oFont BORDER  
oBtn2:cToolTip =  { "Exit color tool","EXIT", 1, CLR_BLACK, 14089979 }
oBtn2:SetColor( 0, )

ACTIVATE DIALOG oDlg CENTER  

Release FONT oFont

RETURN( NIL )

//---------  

STATIC FUNCTION GET_COLOR( nPos, hDC, oBmp, nColor ) 
LOCAL oBMPBrush
LOCAL aRect := GETCLIENTRECT( oBmp:hWnd )

aGrad := { { .5, CLR_WHITE, nColor }, { .5, nColor, CLR_BLACK } }
DEFINE BRUSH oBMPBrush ;
COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, .T. ) // .T: = Vertical

oBMPBrush:End()

RETURN( NIL )

//-----------

STATIC FUNCTION PICK_COLOR( nRow, nCol, oBmp )
LOCAL aColors[2]	
LOCAL hDC := CreateCompatibleDC( oBmp:GetDC() )
LOCAL nRed, nGreen, nBlue

aColors[1]	:= GetPixel( oBmp:hDC, nCol, nRow )
nRed		:= nRGBRed( aColors[1] )
nGreen		:= nRGBGreen( aColors[1] )
nBlue		:= nRGBBlue( aColors[1] )
aColors[2]	:= "nRGB( " + ALLTRIM(STR(nRed)) + ", " + ;
			    ALLTRIM(STR(nGreen)) + ", " + ;
			    ALLTRIM(STR(nBlue)) + " )"
oBmp:ReleaseDC()

RETURN aColors

//-----------

STATIC FUNCTION MAKE_RGB(nColor1)

nRed := nRGBRed( nColor1 )
nGreen := nRGBGreen( nColor1 )
nBlue := nRGBBlue( nColor1 )

cColor1 := "nRGB( " + ALLTRIM(STR(nRed)) + ", " + ;
		     ALLTRIM(STR(nGreen)) + ", " + ;
		     ALLTRIM(STR(nBlue)) + " )"
oGet2:Refresh()
									 
RETURN( NIL )